<?php

include ("inc.php3");
include_ecrire ("inc_acces.php3");

function addrubrique ($id_auteur, $id_rubrique, $add_rub) {
	$query = "INSERT INTO spip_auteurs_rubriques (id_auteur,id_rubrique) VALUES($id_auteur,$add_rub)";
	$result = spip_query($query);
}

function supprubrique ($id_auteur, $supp_rub) {
	$query = "DELETE FROM spip_auteurs_rubriques WHERE id_auteur=$id_auteur AND id_rubrique=$supp_rub";
	$result = spip_query($query);
}

function afficher_auteur_rubriques($leparent){
	global $id_parent;
	global $id_rubrique;
	global $toutes_rubriques;
	global $i;
	
	$i++;
 	$query="SELECT * FROM spip_rubriques WHERE id_parent=$leparent ORDER BY titre";
 	$result=spip_query($query);

	while($row=spip_fetch_array($result)){
		$my_rubrique=$row['id_rubrique'];
		$titre=typo($row['titre']);
	
		if (!ereg(",$my_rubrique,","$toutes_rubriques")){
			$espace="";
			for ($count=0;$count<$i;$count++){$espace.="&nbsp;&nbsp;";}
			$espace .= "|";
			if ($i==1)
				$espace = "*";

			echo "<OPTION VALUE='$my_rubrique'>$espace ".supprimer_tags($titre)."\n";
			afficher_auteur_rubriques($my_rubrique);
		}
	}
	$i=$i-1;
}

if ($connect_toutes_rubriques AND $add_rub=floor($add_rub)){
	$query = "INSERT INTO spip_auteurs_rubriques (id_auteur,id_rubrique) VALUES($id_auteur,$add_rub)";
	$result = spip_query($query);
}
if ($connect_toutes_rubriques AND $supp_rub=floor($supp_rub)){
	$query = "DELETE FROM spip_auteurs_rubriques WHERE id_auteur=$id_auteur AND id_rubrique=$supp_rub";
	$result = spip_query($query);
}


$retour = "auteur_rights.php3?";
if ($tri) {
	$retour .= "tri=$tri";
	if ($tri=='nom' OR $tri=='statut')
		$partri = " "._T('info_par_tri', array('tri' => $tri));
	else if ($tri=='nombre')
		$partri = " "._T('info_par_nombre_article');
}

if ($visiteurs == "oui") {
	debut_page(_T('titre_page_auteurs'),"auteurs","redacteurs");
	$retour .= '&visiteurs=oui';
} else
	debut_page(_T('info_auteurs_par_tri', array('partri' => $partri)),"auteurs","redacteurs");

debut_gauche();
debut_boite_info();
		echo "<p class='arial1'>Cette page est r&eacute;serv&eacute;e aux administrateurs techniques. Elle synth&eacute;tise les droits accord&eacute;s &agrave; chacun des admin. restreints.</p>";
fin_boite_info();



debut_droite();

//
// Construire la requete
//

// limiter les statuts affiches
if (($visiteurs == "oui") AND ($connect_statut == '0minirezo')) {
	$sql_statut_auteurs = " AND auteurs.statut IN ('6forum', '5poubelle')";
	$sql_statut_articles = '';
	$tri = 'nom';
} else if ($connect_statut != '0minirezo') {
	$sql_statut_auteurs = " AND auteurs.statut IN ('0minirezo', '1comite')";
	$sql_statut_articles = " AND articles.statut IN ('prop', 'publie')";
} else {
	$sql_statut_auteurs = " AND auteurs.statut IN ('0minirezo', '1comite', '5poubelle')";
	$sql_statut_articles = "";
}

// tri
switch ($tri) {

case 'statut':
	$sql_order = ' ORDER BY auteurs.statut, login = "", unom';
	$type_requete = 'auteur';
	break;

case 'nom':
default:
	$sql_order = ' ORDER BY unom';
	$type_requete = 'auteur';
}


unset($nombre_auteurs);
$auteurs = Array();

if ($type_requete == 'auteur') {
	$result_auteurs = spip_query("SELECT id_auteur, statut, source, pass, login, nom, email, url_site, messagerie, UPPER(nom) AS unom
		FROM spip_auteurs AS auteurs
		WHERE 1 $sql_statut_auteurs
		$sql_order");
	while ($row = spip_fetch_array($result_auteurs)) {
		$auteurs[$row['id_auteur']] = $row;
		$nombre_auteurs ++;

		$nom_auteur = $row['nom'];
	}

	$result_nombres = spip_query("SELECT auteurs.id_auteur, UPPER(auteurs.nom) AS unom, COUNT(articles.id_article) AS compteur
		FROM spip_auteurs AS auteurs, spip_auteurs_articles AS lien, spip_articles AS articles
		WHERE auteurs.id_auteur=lien.id_auteur AND lien.id_article=articles.id_article
		$sql_statut_auteurs $sql_statut_articles
		GROUP BY auteurs.id_auteur
		$sql_order");
	while ($row = spip_fetch_array($result_nombres))
		$auteurs[$row['id_auteur']]['compteur'] = $row['compteur'];

	// si on n'est pas minirezo, supprimer les auteurs sans article publie
	// sauf les admins, toujours visibles.
	if ($connect_statut != '0minirezo') {
		reset($auteurs);
		while (list(,$auteur) = each ($auteurs)) {
			if (! $auteur['compteur'] AND ($auteur['statut'] != '0minirezo')) {
				unset($auteurs[$auteur['id_auteur']]);
				$nombre_auteurs --;
			}
		}
	}

	// apres avoir supprime les auteurs sans article publie
	// generer les paires lettre/indice pour l'acces direct
	// sur la premiere lettre
	$lettres_nombre_auteurs = 0;
	foreach ($auteurs as $auteur) {
		$lettres_nombre_auteurs ++;
		$premiere_lettre = addslashes(strtoupper(substr($auteur['nom'],0,1)));
		if ($premiere_lettre != $lettre_prec) {
			$lettre[$premiere_lettre] = $lettres_nombre_auteurs-1;
		}
		$lettre_prec = $premiere_lettre;
	}
}

unset ($rub_restreinte);
if ($connect_statut == '0minirezo') { // recuperer les admins restreints
	$restreint = spip_query("SELECT * FROM spip_auteurs_rubriques");
	while ($row = spip_fetch_array($restreint))
		$rub_restreinte[$row['id_auteur']] .= ','.$row['id_rubrique'];
}

if (!$echec AND $redirect_ok == "oui") {
	if ($redirect) {
		@Header("Location: ".rawurldecode($redirect));
		exit; 
	}
	else {
		@Header("Location:auteurs_rights.php3");
		exit; 
	}
}

//
// Affichage
//

echo "<br>";
if ($visiteurs=='oui')
	gros_titre(_T('info_visiteurs'));
else
	gros_titre(_T('info_auteurs'));
echo "<p>";

// reglage du debut
$max_par_page = 80;
if ($debut > $nombre_auteurs - $max_par_page)
	$debut = max(0,$nombre_auteurs - $max_par_page);
$fin = min($nombre_auteurs, $debut + $max_par_page);

// ignorer les $debut premiers
unset ($i);
reset ($auteurs);
while ($i++ < $debut AND each($auteurs));

// ici commence la vraie boucle
debut_cadre_relief('auteur-24.gif');
echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='700' class='arial2' style='border: 1px solid #aaaaaa;'>\n";
echo "<tr bgcolor='#DBE1C5'>";
echo "<td width='20'>";
	$img = "<img src='img_pack/admin-12.gif' alt='' border='0'>";
	if ($tri=='statut')
		echo $img;
	else
		echo "<a href='auteur_rights.php3?tri=statut' title='"._T('lien_trier_statut')."'>$img</a>";

echo "</td><td>";
	if ($tri == '' OR $tri=='nom')
		echo '<b>'._T('info_nom').'</b>';
	else
		echo "<a href='auteur_rights.php3?tri=nom' title='"._T('lien_trier_nom')."'>"._T('info_nom')."</a>";
echo "</td></tr>\n";

if ($nombre_auteurs > $max_par_page) {
	echo "<tr bgcolor='white'><td class='arial1' colspan='".($options == 'avancees' ? 5 : 3)."'>";
	for ($j=0; $j < $nombre_auteurs; $j+=$max_par_page) {
		if ($j > 0) echo " | ";

		if ($j == $debut)
			echo "<b>$j</b>";
		else if ($j > 0)
			echo "<a href=$retour&debut=$j>$j</a>";
		else
			echo " <a href=$retour>0</a>";

		if ($debut > $j  AND $debut < $j+$max_par_page){
			echo " | <b>$debut</b>";
		}
	}
	echo "</td></tr>\n";

	if (($tri == 'nom' OR !$tri) AND $options == 'avancees') {
		echo "<tr bgcolor='white'><td class='arial11' colspan='5'>";
		while (list($key,$val) = each($lettre)) {
			if ($val == $debut)
				echo "<b>$key</b> ";
			else
				echo "<a href=$retour&debut=$val>$key</a> ";
		}
		echo "</td></tr>\n";
	}
	echo "<tr height='5'></tr>";
}



while ($i++ <= $fin && (list(,$row) = each ($auteurs))) {
	// couleur de ligne
	$couleur = ($i % 2) ? '#FFFFFF' : $couleur_claire;
	echo "<tr style='background-color: #eeeeee;'>";

	// statut auteur
	echo "<td style='border-top: 1px solid #cccccc;'>";
	echo bonhomme_statut($row);

	// nom
	echo "</td><td class='verdana11' style='border-top: 1px solid #cccccc;'>";
	echo "<small><a href='auteurs_edit.php3?id_auteur=".$row['id_auteur']."'>".typo($row['nom']).'</a></small>';

	if ($connect_statut == '0minirezo' AND $row['statut']=='0minirezo' AND $rub_restreinte[$row['id_auteur']])
	{
		echo " &nbsp;<small>"._T('statut_admin_restreint')."</small><br>";
		$query_admin = "SELECT lien.id_rubrique, titre FROM spip_auteurs_rubriques AS lien, spip_rubriques AS rubriques WHERE lien.id_auteur=".$row['id_auteur']." AND lien.id_rubrique=rubriques.id_rubrique GROUP BY lien.id_rubrique";
		$result_admin = spip_query($query_admin);

		if (spip_num_rows($result_admin) == 0) {
		echo _T('');
		} else {
			echo _T('info_admin_gere_rubriques')."\n";
			echo "<ul style='list-style-image: url(img_pack/rubrique-12.gif)'>";
			while ($row_admin = spip_fetch_array($result_admin)) {
				$id_rubrique = $row_admin["id_rubrique"];
				$titre = typo($row_admin["titre"]);
				echo "<li>$titre";
				if ($connect_toutes_rubriques AND $connect_id_auteur != $id_auteur) {
					echo " <font size=1>[<a href='auteur_rights.php3?id_auteur=".$row['id_auteur']."&supp_rub=$id_rubrique'>"._T('lien_supprimer_rubrique')."</a>]</font>";
				}
				$toutes_rubriques .= "$id_rubrique,";
			}
			echo "</ul>";
			$toutes_rubriques = ",$toutes_rubriques";
		}

		debut_cadre_enfonce("secteur-24.gif");

		if ($connect_toutes_rubriques AND $connect_id_auteur != $id_auteur) {
			if (spip_num_rows($result_admin) == 0) {
				echo "<p><B>"._T('info_restreindre_rubrique')."</b><BR>";
			} else {
				echo "<p><B>"._T('info_ajouter_rubrique')."</b><BR>";
			}
			debut_cadre_formulaire();
			echo "<FORM ACTION='auteur_rights.php3?id_auteur='".$row['id_auteur']."' METHOD='post'>";
			echo "<INPUT TYPE='Hidden' NAME='id_auteur' VALUE='".$row['id_auteur']."'>";
			echo "<INPUT NAME='id_auteur' VALUE='".$row['id_auteur']."' TYPE='hidden'>";
			echo "<SELECT NAME='add_rub' SIZE=1 CLASS='formo'>";
			echo "<OPTION VALUE='0'>   \n";
					afficher_auteur_rubriques('0');
			echo "</SELECT>";
				echo "<DIV align='right'><INPUT TYPE='submit' CLASS='fondo' NAME='Valider' VALUE='"._T('bouton_valider')."'></DIV>";
			echo "</FORM>";
			$id_parent="";
			$id_rubrique="";
			$toutes_rubriques="";
			$i="";
		}
		fin_cadre_formulaire();
	}		
	echo "</td></tr>\n";
}

echo "</table>\n";


echo "<a name='bas'>";
echo "<table width='706' border='0'>";

$debut_suivant = $debut + $max_par_page;
if ($debut_suivant < $nombre_auteurs OR $debut > 0) {
	echo "<tr height='10'></tr>";
	echo "<tr bgcolor='white'><td align='left'>";
	if ($debut > 0) {
		$debut_prec = strval(max($debut - $max_par_page, 0));
		$link = new Link;
		$link->addVar('debut', $debut_prec);
		echo $link->getForm('GET');
		echo "<input type='submit' name='submit' value='&lt;&lt;&lt;' class='fondo'>";
		echo "</form>";
	}
	echo "</td><td style='text-align: $spip_lang_right'>";
	if ($debut_suivant < $nombre_auteurs) {
		$link = new Link;
		$link->addVar('debut', $debut_suivant);
		echo $link->getForm('GET');
		echo "<input type='submit' name='submit' value='&gt;&gt;&gt;' class='fondo'>";
		echo "</form>";
	}
	echo "</td></tr>\n";
}

echo "</table>\n";



fin_cadre_relief();


fin_page();

?>
